#include <mycpp/util.h>
#include <mycpp/io.h>

#include "cpp_cond_pargen.h"

using namespace MyCpp;
using namespace Pargen;

namespace Scruffy {

static void
print_whsp (File *file,
            Size num_spaces)
{
    for (Size i = 0; i < num_spaces; i++)
        file->print (" ");
}

static void
print_tab (File *file,
           Size nest_level)
{
    print_whsp (file, nest_level * 1);
}

static Ref<Grammar> create_cpp_cond_Identifier ();
static Ref<Grammar> create_cpp_cond_Literal ();
static Ref<Grammar> create_cpp_cond_PrimaryExpression ();
static Ref<Grammar> create_cpp_cond_UnaryExpression ();
static Ref<Grammar> create_cpp_cond_UnaryOperator ();
static Ref<Grammar> create_cpp_cond_MultiplicativeExpression ();
static Ref<Grammar> create_cpp_cond_AdditiveExpression ();
static Ref<Grammar> create_cpp_cond_ShiftExpression ();
static Ref<Grammar> create_cpp_cond_RelationalExpression ();
static Ref<Grammar> create_cpp_cond_EqualityExpression ();
static Ref<Grammar> create_cpp_cond_AndExpression ();
static Ref<Grammar> create_cpp_cond_ExclusiveOrExpression ();
static Ref<Grammar> create_cpp_cond_InclusiveOrExpression ();
static Ref<Grammar> create_cpp_cond_LogicalAndExpression ();
static Ref<Grammar> create_cpp_cond_LogicalOrExpression ();
static Ref<Grammar> create_cpp_cond_ConditionalExpression ();

bool cpp_cond_Identifier_match_func (
        CppCond_Identifier *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool __pargen_cpp_cond_Identifier_match_func (
        ParserElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data)
{
    CppCondElement * const &_el = static_cast <CppCondElement*> (parser_element);
    abortIf (_el->cpp_cond_element_type != CppCondElement::_Identifier);

    CppCond_Identifier * const &el = static_cast <CppCond_Identifier*> (_el);

    return cpp_cond_Identifier_match_func (el, parser_control, data);
}

static void
cpp_cond_Identifier_set_any_token (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_Identifier);

    CppCond_Identifier * const &self = static_cast <CppCond_Identifier*> (__self);

    self->any_token = static_cast <ParserElement_Token*> (___el);
}

static ParserElement*
cpp_cond_Identifier_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_Identifier))) CppCond_Identifier;
}

static Ref<Grammar>
create_cpp_cond_Identifier ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_Identifier_creation_func));
    grammar->name = String::forData ("Identifier");
    grammar->match_func = __pargen_cpp_cond_Identifier_match_func;

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (""));
        entry->grammar = grammar__immediate;
        entry->assignment_func = cpp_cond_Identifier_set_any_token;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_Identifier (CppCond_Identifier const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) Identifier\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("Identifier\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: \n");
}

bool cpp_cond_Literal_match_func (
        CppCond_Literal *parser_element,
        Pargen::ParserControl *parser_control,
        void *data);

bool __pargen_cpp_cond_Literal_match_func (
        ParserElement *parser_element,
        Pargen::ParserControl *parser_control,
        void *data)
{
    CppCondElement * const &_el = static_cast <CppCondElement*> (parser_element);
    abortIf (_el->cpp_cond_element_type != CppCondElement::_Literal);

    CppCond_Literal * const &el = static_cast <CppCond_Literal*> (_el);

    return cpp_cond_Literal_match_func (el, parser_control, data);
}

static void
cpp_cond_Literal_set_any_token (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_Literal);

    CppCond_Literal * const &self = static_cast <CppCond_Literal*> (__self);

    self->any_token = static_cast <ParserElement_Token*> (___el);
}

static ParserElement*
cpp_cond_Literal_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_Literal))) CppCond_Literal;
}

static Ref<Grammar>
create_cpp_cond_Literal ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_Literal_creation_func));
    grammar->name = String::forData ("Literal");
    grammar->match_func = __pargen_cpp_cond_Literal_match_func;

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (""));
        entry->grammar = grammar__immediate;
        entry->assignment_func = cpp_cond_Literal_set_any_token;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_Literal (CppCond_Literal const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) Literal\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("Literal\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: \n");
}

static void
cpp_cond_PrimaryExpression_Literal_set_literal (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_PrimaryExpression ||
             __el->cpp_cond_element_type != CppCondElement::_Literal);

    CppCond_PrimaryExpression * const &_self = static_cast <CppCond_PrimaryExpression*> (__self);

    abortIf (_self->primary_expression_type != CppCond_PrimaryExpression::_Literal);

    CppCond_PrimaryExpression_Literal * const &self = static_cast <CppCond_PrimaryExpression_Literal*> (_self);

    self->literal = static_cast <CppCond_Literal*> (___el);
}

static ParserElement*
cpp_cond_PrimaryExpression_Literal_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_PrimaryExpression_Literal))) CppCond_PrimaryExpression_Literal;
}

static Ref<Grammar>
create_cpp_cond_PrimaryExpression_Literal ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_PrimaryExpression_Literal_creation_func));
    grammar->name = String::forData ("PrimaryExpression_Literal");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_Literal ();
        entry->assignment_func = cpp_cond_PrimaryExpression_Literal_set_literal;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_PrimaryExpression_Literal (CppCond_PrimaryExpression_Literal const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) PrimaryExpression_Literal\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("PrimaryExpression_Literal\n");

    dump_cpp_cond_Literal (el->literal, nest_level + 1);

}

static void
cpp_cond_PrimaryExpression_Braces_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_PrimaryExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ConditionalExpression);

    CppCond_PrimaryExpression * const &_self = static_cast <CppCond_PrimaryExpression*> (__self);

    abortIf (_self->primary_expression_type != CppCond_PrimaryExpression::_Braces);

    CppCond_PrimaryExpression_Braces * const &self = static_cast <CppCond_PrimaryExpression_Braces*> (_self);

    self->expression = static_cast <CppCond_ConditionalExpression*> (___el);
}

static ParserElement*
cpp_cond_PrimaryExpression_Braces_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_PrimaryExpression_Braces))) CppCond_PrimaryExpression_Braces;
}

static Ref<Grammar>
create_cpp_cond_PrimaryExpression_Braces ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_PrimaryExpression_Braces_creation_func));
    grammar->name = String::forData ("PrimaryExpression_Braces");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("("));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ConditionalExpression ();
        entry->assignment_func = cpp_cond_PrimaryExpression_Braces_set_expression;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (")"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_PrimaryExpression_Braces (CppCond_PrimaryExpression_Braces const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) PrimaryExpression_Braces\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("PrimaryExpression_Braces\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: (\n");
    dump_cpp_cond_ConditionalExpression (el->expression, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: )\n");
}

static Ref<Grammar>
create_cpp_cond_PrimaryExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("PrimaryExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_PrimaryExpression_Literal ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_PrimaryExpression_Braces ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_PrimaryExpression (CppCond_PrimaryExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) PrimaryExpression\n");
        return;
    }

    switch (el->primary_expression_type) {
        case CppCond_PrimaryExpression::_Literal:
            dump_cpp_cond_PrimaryExpression_Literal (static_cast <CppCond_PrimaryExpression_Literal const *> (el), nest_level + 0);
            break;
        case CppCond_PrimaryExpression::_Braces:
            dump_cpp_cond_PrimaryExpression_Braces (static_cast <CppCond_PrimaryExpression_Braces const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_UnaryExpression_Defined_set_identifier (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_UnaryExpression ||
             __el->cpp_cond_element_type != CppCondElement::_Identifier);

    CppCond_UnaryExpression * const &_self = static_cast <CppCond_UnaryExpression*> (__self);

    abortIf (_self->unary_expression_type != CppCond_UnaryExpression::_Defined);

    CppCond_UnaryExpression_Defined * const &self = static_cast <CppCond_UnaryExpression_Defined*> (_self);

    self->identifier = static_cast <CppCond_Identifier*> (___el);
}

static ParserElement*
cpp_cond_UnaryExpression_Defined_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryExpression_Defined))) CppCond_UnaryExpression_Defined;
}

static Ref<Grammar>
create_cpp_cond_UnaryExpression_Defined ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryExpression_Defined_creation_func));
    grammar->name = String::forData ("UnaryExpression_Defined");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("defined"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_Identifier ();
        entry->assignment_func = cpp_cond_UnaryExpression_Defined_set_identifier;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryExpression_Defined (CppCond_UnaryExpression_Defined const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryExpression_Defined\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryExpression_Defined\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: defined\n");
    dump_cpp_cond_Identifier (el->identifier, nest_level + 1);

}

static void
cpp_cond_UnaryExpression_DefinedBraces_set_identifier (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_UnaryExpression ||
             __el->cpp_cond_element_type != CppCondElement::_Identifier);

    CppCond_UnaryExpression * const &_self = static_cast <CppCond_UnaryExpression*> (__self);

    abortIf (_self->unary_expression_type != CppCond_UnaryExpression::_DefinedBraces);

    CppCond_UnaryExpression_DefinedBraces * const &self = static_cast <CppCond_UnaryExpression_DefinedBraces*> (_self);

    self->identifier = static_cast <CppCond_Identifier*> (___el);
}

static ParserElement*
cpp_cond_UnaryExpression_DefinedBraces_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryExpression_DefinedBraces))) CppCond_UnaryExpression_DefinedBraces;
}

static Ref<Grammar>
create_cpp_cond_UnaryExpression_DefinedBraces ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryExpression_DefinedBraces_creation_func));
    grammar->name = String::forData ("UnaryExpression_DefinedBraces");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("defined"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("("));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_Identifier ();
        entry->assignment_func = cpp_cond_UnaryExpression_DefinedBraces_set_identifier;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (")"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryExpression_DefinedBraces (CppCond_UnaryExpression_DefinedBraces const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryExpression_DefinedBraces\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryExpression_DefinedBraces\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: defined\n");
    print_tab (errf, nest_level + 1);
    errf->print ("token: (\n");
    dump_cpp_cond_Identifier (el->identifier, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: )\n");
}

static void
cpp_cond_UnaryExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_UnaryExpression ||
             __el->cpp_cond_element_type != CppCondElement::_PrimaryExpression);

    CppCond_UnaryExpression * const &_self = static_cast <CppCond_UnaryExpression*> (__self);

    abortIf (_self->unary_expression_type != CppCond_UnaryExpression::_Expression);

    CppCond_UnaryExpression_Expression * const &self = static_cast <CppCond_UnaryExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_PrimaryExpression*> (___el);
}

static ParserElement*
cpp_cond_UnaryExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryExpression_Expression))) CppCond_UnaryExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_UnaryExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryExpression_Expression_creation_func));
    grammar->name = String::forData ("UnaryExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_PrimaryExpression ();
        entry->assignment_func = cpp_cond_UnaryExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryExpression_Expression (CppCond_UnaryExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryExpression_Expression\n");

    dump_cpp_cond_PrimaryExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_UnaryExpression_UnaryOperator_set_unaryOperator (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_UnaryExpression ||
             __el->cpp_cond_element_type != CppCondElement::_UnaryOperator);

    CppCond_UnaryExpression * const &_self = static_cast <CppCond_UnaryExpression*> (__self);

    abortIf (_self->unary_expression_type != CppCond_UnaryExpression::_UnaryOperator);

    CppCond_UnaryExpression_UnaryOperator * const &self = static_cast <CppCond_UnaryExpression_UnaryOperator*> (_self);

    self->unaryOperator = static_cast <CppCond_UnaryOperator*> (___el);
}

static void
cpp_cond_UnaryExpression_UnaryOperator_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_UnaryExpression ||
             __el->cpp_cond_element_type != CppCondElement::_UnaryExpression);

    CppCond_UnaryExpression * const &_self = static_cast <CppCond_UnaryExpression*> (__self);

    abortIf (_self->unary_expression_type != CppCond_UnaryExpression::_UnaryOperator);

    CppCond_UnaryExpression_UnaryOperator * const &self = static_cast <CppCond_UnaryExpression_UnaryOperator*> (_self);

    self->expression = static_cast <CppCond_UnaryExpression*> (___el);
}

static ParserElement*
cpp_cond_UnaryExpression_UnaryOperator_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryExpression_UnaryOperator))) CppCond_UnaryExpression_UnaryOperator;
}

static Ref<Grammar>
create_cpp_cond_UnaryExpression_UnaryOperator ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryExpression_UnaryOperator_creation_func));
    grammar->name = String::forData ("UnaryExpression_UnaryOperator");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryOperator ();
        entry->assignment_func = cpp_cond_UnaryExpression_UnaryOperator_set_unaryOperator;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression ();
        entry->assignment_func = cpp_cond_UnaryExpression_UnaryOperator_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryExpression_UnaryOperator (CppCond_UnaryExpression_UnaryOperator const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryExpression_UnaryOperator\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryExpression_UnaryOperator\n");

    dump_cpp_cond_UnaryOperator (el->unaryOperator, nest_level + 1);

    dump_cpp_cond_UnaryExpression (el->expression, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_UnaryExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("UnaryExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression_Defined ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression_DefinedBraces ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression_UnaryOperator ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryExpression (CppCond_UnaryExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryExpression\n");
        return;
    }

    switch (el->unary_expression_type) {
        case CppCond_UnaryExpression::_Defined:
            dump_cpp_cond_UnaryExpression_Defined (static_cast <CppCond_UnaryExpression_Defined const *> (el), nest_level + 0);
            break;
        case CppCond_UnaryExpression::_DefinedBraces:
            dump_cpp_cond_UnaryExpression_DefinedBraces (static_cast <CppCond_UnaryExpression_DefinedBraces const *> (el), nest_level + 0);
            break;
        case CppCond_UnaryExpression::_Expression:
            dump_cpp_cond_UnaryExpression_Expression (static_cast <CppCond_UnaryExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_UnaryExpression::_UnaryOperator:
            dump_cpp_cond_UnaryExpression_UnaryOperator (static_cast <CppCond_UnaryExpression_UnaryOperator const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static ParserElement*
cpp_cond_UnaryOperator_Plus_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryOperator_Plus))) CppCond_UnaryOperator_Plus;
}

static Ref<Grammar>
create_cpp_cond_UnaryOperator_Plus ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryOperator_Plus_creation_func));
    grammar->name = String::forData ("UnaryOperator_Plus");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("+"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryOperator_Plus (CppCond_UnaryOperator_Plus const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryOperator_Plus\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryOperator_Plus\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: +\n");
}

static ParserElement*
cpp_cond_UnaryOperator_Minus_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryOperator_Minus))) CppCond_UnaryOperator_Minus;
}

static Ref<Grammar>
create_cpp_cond_UnaryOperator_Minus ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryOperator_Minus_creation_func));
    grammar->name = String::forData ("UnaryOperator_Minus");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("-"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryOperator_Minus (CppCond_UnaryOperator_Minus const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryOperator_Minus\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryOperator_Minus\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: -\n");
}

static ParserElement*
cpp_cond_UnaryOperator_Not_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryOperator_Not))) CppCond_UnaryOperator_Not;
}

static Ref<Grammar>
create_cpp_cond_UnaryOperator_Not ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryOperator_Not_creation_func));
    grammar->name = String::forData ("UnaryOperator_Not");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("!"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryOperator_Not (CppCond_UnaryOperator_Not const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryOperator_Not\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryOperator_Not\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: !\n");
}

static ParserElement*
cpp_cond_UnaryOperator_Inversion_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_UnaryOperator_Inversion))) CppCond_UnaryOperator_Inversion;
}

static Ref<Grammar>
create_cpp_cond_UnaryOperator_Inversion ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_UnaryOperator_Inversion_creation_func));
    grammar->name = String::forData ("UnaryOperator_Inversion");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("~"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryOperator_Inversion (CppCond_UnaryOperator_Inversion const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryOperator_Inversion\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("UnaryOperator_Inversion\n");

    print_tab (errf, nest_level + 1);
    errf->print ("token: ~\n");
}

static Ref<Grammar>
create_cpp_cond_UnaryOperator ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("UnaryOperator");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryOperator_Plus ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryOperator_Minus ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryOperator_Not ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryOperator_Inversion ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_UnaryOperator (CppCond_UnaryOperator const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) UnaryOperator\n");
        return;
    }

    switch (el->unary_operator_type) {
        case CppCond_UnaryOperator::_Plus:
            dump_cpp_cond_UnaryOperator_Plus (static_cast <CppCond_UnaryOperator_Plus const *> (el), nest_level + 0);
            break;
        case CppCond_UnaryOperator::_Minus:
            dump_cpp_cond_UnaryOperator_Minus (static_cast <CppCond_UnaryOperator_Minus const *> (el), nest_level + 0);
            break;
        case CppCond_UnaryOperator::_Not:
            dump_cpp_cond_UnaryOperator_Not (static_cast <CppCond_UnaryOperator_Not const *> (el), nest_level + 0);
            break;
        case CppCond_UnaryOperator::_Inversion:
            dump_cpp_cond_UnaryOperator_Inversion (static_cast <CppCond_UnaryOperator_Inversion const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_MultiplicativeExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression ||
             __el->cpp_cond_element_type != CppCondElement::_UnaryExpression);

    CppCond_MultiplicativeExpression * const &_self = static_cast <CppCond_MultiplicativeExpression*> (__self);

    abortIf (_self->multiplicative_expression_type != CppCond_MultiplicativeExpression::_Expression);

    CppCond_MultiplicativeExpression_Expression * const &self = static_cast <CppCond_MultiplicativeExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_UnaryExpression*> (___el);
}

static ParserElement*
cpp_cond_MultiplicativeExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_MultiplicativeExpression_Expression))) CppCond_MultiplicativeExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_MultiplicativeExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_MultiplicativeExpression_Expression_creation_func));
    grammar->name = String::forData ("MultiplicativeExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression ();
        entry->assignment_func = cpp_cond_MultiplicativeExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_MultiplicativeExpression_Expression (CppCond_MultiplicativeExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) MultiplicativeExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("MultiplicativeExpression_Expression\n");

    dump_cpp_cond_UnaryExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_MultiplicativeExpression_Multiply_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression ||
             __el->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression);

    CppCond_MultiplicativeExpression * const &_self = static_cast <CppCond_MultiplicativeExpression*> (__self);

    abortIf (_self->multiplicative_expression_type != CppCond_MultiplicativeExpression::_Multiply);

    CppCond_MultiplicativeExpression_Multiply * const &self = static_cast <CppCond_MultiplicativeExpression_Multiply*> (_self);

    self->left = static_cast <CppCond_MultiplicativeExpression*> (___el);
}

static void
cpp_cond_MultiplicativeExpression_Multiply_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression ||
             __el->cpp_cond_element_type != CppCondElement::_UnaryExpression);

    CppCond_MultiplicativeExpression * const &_self = static_cast <CppCond_MultiplicativeExpression*> (__self);

    abortIf (_self->multiplicative_expression_type != CppCond_MultiplicativeExpression::_Multiply);

    CppCond_MultiplicativeExpression_Multiply * const &self = static_cast <CppCond_MultiplicativeExpression_Multiply*> (_self);

    self->right = static_cast <CppCond_UnaryExpression*> (___el);
}

static ParserElement*
cpp_cond_MultiplicativeExpression_Multiply_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_MultiplicativeExpression_Multiply))) CppCond_MultiplicativeExpression_Multiply;
}

static Ref<Grammar>
create_cpp_cond_MultiplicativeExpression_Multiply ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_MultiplicativeExpression_Multiply_creation_func));
    grammar->name = String::forData ("MultiplicativeExpression_Multiply");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression ();
        entry->assignment_func = cpp_cond_MultiplicativeExpression_Multiply_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("*"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression ();
        entry->assignment_func = cpp_cond_MultiplicativeExpression_Multiply_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_MultiplicativeExpression_Multiply (CppCond_MultiplicativeExpression_Multiply const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) MultiplicativeExpression_Multiply\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("MultiplicativeExpression_Multiply\n");

    dump_cpp_cond_MultiplicativeExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: *\n");
    dump_cpp_cond_UnaryExpression (el->right, nest_level + 1);

}

static void
cpp_cond_MultiplicativeExpression_Divide_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression ||
             __el->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression);

    CppCond_MultiplicativeExpression * const &_self = static_cast <CppCond_MultiplicativeExpression*> (__self);

    abortIf (_self->multiplicative_expression_type != CppCond_MultiplicativeExpression::_Divide);

    CppCond_MultiplicativeExpression_Divide * const &self = static_cast <CppCond_MultiplicativeExpression_Divide*> (_self);

    self->left = static_cast <CppCond_MultiplicativeExpression*> (___el);
}

static void
cpp_cond_MultiplicativeExpression_Divide_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression ||
             __el->cpp_cond_element_type != CppCondElement::_UnaryExpression);

    CppCond_MultiplicativeExpression * const &_self = static_cast <CppCond_MultiplicativeExpression*> (__self);

    abortIf (_self->multiplicative_expression_type != CppCond_MultiplicativeExpression::_Divide);

    CppCond_MultiplicativeExpression_Divide * const &self = static_cast <CppCond_MultiplicativeExpression_Divide*> (_self);

    self->right = static_cast <CppCond_UnaryExpression*> (___el);
}

static ParserElement*
cpp_cond_MultiplicativeExpression_Divide_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_MultiplicativeExpression_Divide))) CppCond_MultiplicativeExpression_Divide;
}

static Ref<Grammar>
create_cpp_cond_MultiplicativeExpression_Divide ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_MultiplicativeExpression_Divide_creation_func));
    grammar->name = String::forData ("MultiplicativeExpression_Divide");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression ();
        entry->assignment_func = cpp_cond_MultiplicativeExpression_Divide_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("/"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression ();
        entry->assignment_func = cpp_cond_MultiplicativeExpression_Divide_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_MultiplicativeExpression_Divide (CppCond_MultiplicativeExpression_Divide const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) MultiplicativeExpression_Divide\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("MultiplicativeExpression_Divide\n");

    dump_cpp_cond_MultiplicativeExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: /\n");
    dump_cpp_cond_UnaryExpression (el->right, nest_level + 1);

}

static void
cpp_cond_MultiplicativeExpression_Remainder_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression ||
             __el->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression);

    CppCond_MultiplicativeExpression * const &_self = static_cast <CppCond_MultiplicativeExpression*> (__self);

    abortIf (_self->multiplicative_expression_type != CppCond_MultiplicativeExpression::_Remainder);

    CppCond_MultiplicativeExpression_Remainder * const &self = static_cast <CppCond_MultiplicativeExpression_Remainder*> (_self);

    self->left = static_cast <CppCond_MultiplicativeExpression*> (___el);
}

static void
cpp_cond_MultiplicativeExpression_Remainder_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression ||
             __el->cpp_cond_element_type != CppCondElement::_UnaryExpression);

    CppCond_MultiplicativeExpression * const &_self = static_cast <CppCond_MultiplicativeExpression*> (__self);

    abortIf (_self->multiplicative_expression_type != CppCond_MultiplicativeExpression::_Remainder);

    CppCond_MultiplicativeExpression_Remainder * const &self = static_cast <CppCond_MultiplicativeExpression_Remainder*> (_self);

    self->right = static_cast <CppCond_UnaryExpression*> (___el);
}

static ParserElement*
cpp_cond_MultiplicativeExpression_Remainder_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_MultiplicativeExpression_Remainder))) CppCond_MultiplicativeExpression_Remainder;
}

static Ref<Grammar>
create_cpp_cond_MultiplicativeExpression_Remainder ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_MultiplicativeExpression_Remainder_creation_func));
    grammar->name = String::forData ("MultiplicativeExpression_Remainder");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression ();
        entry->assignment_func = cpp_cond_MultiplicativeExpression_Remainder_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("%"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_UnaryExpression ();
        entry->assignment_func = cpp_cond_MultiplicativeExpression_Remainder_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_MultiplicativeExpression_Remainder (CppCond_MultiplicativeExpression_Remainder const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) MultiplicativeExpression_Remainder\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("MultiplicativeExpression_Remainder\n");

    dump_cpp_cond_MultiplicativeExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: %\n");
    dump_cpp_cond_UnaryExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_MultiplicativeExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("MultiplicativeExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression_Multiply ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression_Divide ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression_Remainder ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_MultiplicativeExpression (CppCond_MultiplicativeExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) MultiplicativeExpression\n");
        return;
    }

    switch (el->multiplicative_expression_type) {
        case CppCond_MultiplicativeExpression::_Expression:
            dump_cpp_cond_MultiplicativeExpression_Expression (static_cast <CppCond_MultiplicativeExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_MultiplicativeExpression::_Multiply:
            dump_cpp_cond_MultiplicativeExpression_Multiply (static_cast <CppCond_MultiplicativeExpression_Multiply const *> (el), nest_level + 0);
            break;
        case CppCond_MultiplicativeExpression::_Divide:
            dump_cpp_cond_MultiplicativeExpression_Divide (static_cast <CppCond_MultiplicativeExpression_Divide const *> (el), nest_level + 0);
            break;
        case CppCond_MultiplicativeExpression::_Remainder:
            dump_cpp_cond_MultiplicativeExpression_Remainder (static_cast <CppCond_MultiplicativeExpression_Remainder const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_AdditiveExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AdditiveExpression ||
             __el->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression);

    CppCond_AdditiveExpression * const &_self = static_cast <CppCond_AdditiveExpression*> (__self);

    abortIf (_self->additive_expression_type != CppCond_AdditiveExpression::_Expression);

    CppCond_AdditiveExpression_Expression * const &self = static_cast <CppCond_AdditiveExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_MultiplicativeExpression*> (___el);
}

static ParserElement*
cpp_cond_AdditiveExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_AdditiveExpression_Expression))) CppCond_AdditiveExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_AdditiveExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_AdditiveExpression_Expression_creation_func));
    grammar->name = String::forData ("AdditiveExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression ();
        entry->assignment_func = cpp_cond_AdditiveExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_AdditiveExpression_Expression (CppCond_AdditiveExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) AdditiveExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("AdditiveExpression_Expression\n");

    dump_cpp_cond_MultiplicativeExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_AdditiveExpression_Plus_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AdditiveExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AdditiveExpression);

    CppCond_AdditiveExpression * const &_self = static_cast <CppCond_AdditiveExpression*> (__self);

    abortIf (_self->additive_expression_type != CppCond_AdditiveExpression::_Plus);

    CppCond_AdditiveExpression_Plus * const &self = static_cast <CppCond_AdditiveExpression_Plus*> (_self);

    self->left = static_cast <CppCond_AdditiveExpression*> (___el);
}

static void
cpp_cond_AdditiveExpression_Plus_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AdditiveExpression ||
             __el->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression);

    CppCond_AdditiveExpression * const &_self = static_cast <CppCond_AdditiveExpression*> (__self);

    abortIf (_self->additive_expression_type != CppCond_AdditiveExpression::_Plus);

    CppCond_AdditiveExpression_Plus * const &self = static_cast <CppCond_AdditiveExpression_Plus*> (_self);

    self->right = static_cast <CppCond_MultiplicativeExpression*> (___el);
}

static ParserElement*
cpp_cond_AdditiveExpression_Plus_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_AdditiveExpression_Plus))) CppCond_AdditiveExpression_Plus;
}

static Ref<Grammar>
create_cpp_cond_AdditiveExpression_Plus ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_AdditiveExpression_Plus_creation_func));
    grammar->name = String::forData ("AdditiveExpression_Plus");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression ();
        entry->assignment_func = cpp_cond_AdditiveExpression_Plus_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("+"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression ();
        entry->assignment_func = cpp_cond_AdditiveExpression_Plus_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_AdditiveExpression_Plus (CppCond_AdditiveExpression_Plus const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) AdditiveExpression_Plus\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("AdditiveExpression_Plus\n");

    dump_cpp_cond_AdditiveExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: +\n");
    dump_cpp_cond_MultiplicativeExpression (el->right, nest_level + 1);

}

static void
cpp_cond_AdditiveExpression_Minus_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AdditiveExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AdditiveExpression);

    CppCond_AdditiveExpression * const &_self = static_cast <CppCond_AdditiveExpression*> (__self);

    abortIf (_self->additive_expression_type != CppCond_AdditiveExpression::_Minus);

    CppCond_AdditiveExpression_Minus * const &self = static_cast <CppCond_AdditiveExpression_Minus*> (_self);

    self->left = static_cast <CppCond_AdditiveExpression*> (___el);
}

static void
cpp_cond_AdditiveExpression_Minus_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AdditiveExpression ||
             __el->cpp_cond_element_type != CppCondElement::_MultiplicativeExpression);

    CppCond_AdditiveExpression * const &_self = static_cast <CppCond_AdditiveExpression*> (__self);

    abortIf (_self->additive_expression_type != CppCond_AdditiveExpression::_Minus);

    CppCond_AdditiveExpression_Minus * const &self = static_cast <CppCond_AdditiveExpression_Minus*> (_self);

    self->right = static_cast <CppCond_MultiplicativeExpression*> (___el);
}

static ParserElement*
cpp_cond_AdditiveExpression_Minus_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_AdditiveExpression_Minus))) CppCond_AdditiveExpression_Minus;
}

static Ref<Grammar>
create_cpp_cond_AdditiveExpression_Minus ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_AdditiveExpression_Minus_creation_func));
    grammar->name = String::forData ("AdditiveExpression_Minus");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression ();
        entry->assignment_func = cpp_cond_AdditiveExpression_Minus_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("-"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_MultiplicativeExpression ();
        entry->assignment_func = cpp_cond_AdditiveExpression_Minus_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_AdditiveExpression_Minus (CppCond_AdditiveExpression_Minus const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) AdditiveExpression_Minus\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("AdditiveExpression_Minus\n");

    dump_cpp_cond_AdditiveExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: -\n");
    dump_cpp_cond_MultiplicativeExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_AdditiveExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("AdditiveExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression_Plus ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression_Minus ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_AdditiveExpression (CppCond_AdditiveExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) AdditiveExpression\n");
        return;
    }

    switch (el->additive_expression_type) {
        case CppCond_AdditiveExpression::_Expression:
            dump_cpp_cond_AdditiveExpression_Expression (static_cast <CppCond_AdditiveExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_AdditiveExpression::_Plus:
            dump_cpp_cond_AdditiveExpression_Plus (static_cast <CppCond_AdditiveExpression_Plus const *> (el), nest_level + 0);
            break;
        case CppCond_AdditiveExpression::_Minus:
            dump_cpp_cond_AdditiveExpression_Minus (static_cast <CppCond_AdditiveExpression_Minus const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_ShiftExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ShiftExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AdditiveExpression);

    CppCond_ShiftExpression * const &_self = static_cast <CppCond_ShiftExpression*> (__self);

    abortIf (_self->shift_expression_type != CppCond_ShiftExpression::_Expression);

    CppCond_ShiftExpression_Expression * const &self = static_cast <CppCond_ShiftExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_AdditiveExpression*> (___el);
}

static ParserElement*
cpp_cond_ShiftExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_ShiftExpression_Expression))) CppCond_ShiftExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_ShiftExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_ShiftExpression_Expression_creation_func));
    grammar->name = String::forData ("ShiftExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression ();
        entry->assignment_func = cpp_cond_ShiftExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ShiftExpression_Expression (CppCond_ShiftExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ShiftExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("ShiftExpression_Expression\n");

    dump_cpp_cond_AdditiveExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_ShiftExpression_LeftShift_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ShiftExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ShiftExpression);

    CppCond_ShiftExpression * const &_self = static_cast <CppCond_ShiftExpression*> (__self);

    abortIf (_self->shift_expression_type != CppCond_ShiftExpression::_LeftShift);

    CppCond_ShiftExpression_LeftShift * const &self = static_cast <CppCond_ShiftExpression_LeftShift*> (_self);

    self->left = static_cast <CppCond_ShiftExpression*> (___el);
}

static void
cpp_cond_ShiftExpression_LeftShift_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ShiftExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AdditiveExpression);

    CppCond_ShiftExpression * const &_self = static_cast <CppCond_ShiftExpression*> (__self);

    abortIf (_self->shift_expression_type != CppCond_ShiftExpression::_LeftShift);

    CppCond_ShiftExpression_LeftShift * const &self = static_cast <CppCond_ShiftExpression_LeftShift*> (_self);

    self->right = static_cast <CppCond_AdditiveExpression*> (___el);
}

static ParserElement*
cpp_cond_ShiftExpression_LeftShift_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_ShiftExpression_LeftShift))) CppCond_ShiftExpression_LeftShift;
}

static Ref<Grammar>
create_cpp_cond_ShiftExpression_LeftShift ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_ShiftExpression_LeftShift_creation_func));
    grammar->name = String::forData ("ShiftExpression_LeftShift");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression ();
        entry->assignment_func = cpp_cond_ShiftExpression_LeftShift_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("<<"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression ();
        entry->assignment_func = cpp_cond_ShiftExpression_LeftShift_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ShiftExpression_LeftShift (CppCond_ShiftExpression_LeftShift const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ShiftExpression_LeftShift\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("ShiftExpression_LeftShift\n");

    dump_cpp_cond_ShiftExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: <<\n");
    dump_cpp_cond_AdditiveExpression (el->right, nest_level + 1);

}

static void
cpp_cond_ShiftExpression_RightShift_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ShiftExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ShiftExpression);

    CppCond_ShiftExpression * const &_self = static_cast <CppCond_ShiftExpression*> (__self);

    abortIf (_self->shift_expression_type != CppCond_ShiftExpression::_RightShift);

    CppCond_ShiftExpression_RightShift * const &self = static_cast <CppCond_ShiftExpression_RightShift*> (_self);

    self->left = static_cast <CppCond_ShiftExpression*> (___el);
}

static void
cpp_cond_ShiftExpression_RightShift_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ShiftExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AdditiveExpression);

    CppCond_ShiftExpression * const &_self = static_cast <CppCond_ShiftExpression*> (__self);

    abortIf (_self->shift_expression_type != CppCond_ShiftExpression::_RightShift);

    CppCond_ShiftExpression_RightShift * const &self = static_cast <CppCond_ShiftExpression_RightShift*> (_self);

    self->right = static_cast <CppCond_AdditiveExpression*> (___el);
}

static ParserElement*
cpp_cond_ShiftExpression_RightShift_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_ShiftExpression_RightShift))) CppCond_ShiftExpression_RightShift;
}

static Ref<Grammar>
create_cpp_cond_ShiftExpression_RightShift ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_ShiftExpression_RightShift_creation_func));
    grammar->name = String::forData ("ShiftExpression_RightShift");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression ();
        entry->assignment_func = cpp_cond_ShiftExpression_RightShift_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (">>"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AdditiveExpression ();
        entry->assignment_func = cpp_cond_ShiftExpression_RightShift_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ShiftExpression_RightShift (CppCond_ShiftExpression_RightShift const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ShiftExpression_RightShift\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("ShiftExpression_RightShift\n");

    dump_cpp_cond_ShiftExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: >>\n");
    dump_cpp_cond_AdditiveExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_ShiftExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("ShiftExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression_LeftShift ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression_RightShift ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ShiftExpression (CppCond_ShiftExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ShiftExpression\n");
        return;
    }

    switch (el->shift_expression_type) {
        case CppCond_ShiftExpression::_Expression:
            dump_cpp_cond_ShiftExpression_Expression (static_cast <CppCond_ShiftExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_ShiftExpression::_LeftShift:
            dump_cpp_cond_ShiftExpression_LeftShift (static_cast <CppCond_ShiftExpression_LeftShift const *> (el), nest_level + 0);
            break;
        case CppCond_ShiftExpression::_RightShift:
            dump_cpp_cond_ShiftExpression_RightShift (static_cast <CppCond_ShiftExpression_RightShift const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_RelationalExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ShiftExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_Expression);

    CppCond_RelationalExpression_Expression * const &self = static_cast <CppCond_RelationalExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_ShiftExpression*> (___el);
}

static ParserElement*
cpp_cond_RelationalExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_RelationalExpression_Expression))) CppCond_RelationalExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_RelationalExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_RelationalExpression_Expression_creation_func));
    grammar->name = String::forData ("RelationalExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_RelationalExpression_Expression (CppCond_RelationalExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) RelationalExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("RelationalExpression_Expression\n");

    dump_cpp_cond_ShiftExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_RelationalExpression_Less_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_RelationalExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_Less);

    CppCond_RelationalExpression_Less * const &self = static_cast <CppCond_RelationalExpression_Less*> (_self);

    self->left = static_cast <CppCond_RelationalExpression*> (___el);
}

static void
cpp_cond_RelationalExpression_Less_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ShiftExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_Less);

    CppCond_RelationalExpression_Less * const &self = static_cast <CppCond_RelationalExpression_Less*> (_self);

    self->right = static_cast <CppCond_ShiftExpression*> (___el);
}

static ParserElement*
cpp_cond_RelationalExpression_Less_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_RelationalExpression_Less))) CppCond_RelationalExpression_Less;
}

static Ref<Grammar>
create_cpp_cond_RelationalExpression_Less ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_RelationalExpression_Less_creation_func));
    grammar->name = String::forData ("RelationalExpression_Less");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_Less_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("<"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_Less_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_RelationalExpression_Less (CppCond_RelationalExpression_Less const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) RelationalExpression_Less\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("RelationalExpression_Less\n");

    dump_cpp_cond_RelationalExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: <\n");
    dump_cpp_cond_ShiftExpression (el->right, nest_level + 1);

}

static void
cpp_cond_RelationalExpression_Greater_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_RelationalExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_Greater);

    CppCond_RelationalExpression_Greater * const &self = static_cast <CppCond_RelationalExpression_Greater*> (_self);

    self->left = static_cast <CppCond_RelationalExpression*> (___el);
}

static void
cpp_cond_RelationalExpression_Greater_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ShiftExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_Greater);

    CppCond_RelationalExpression_Greater * const &self = static_cast <CppCond_RelationalExpression_Greater*> (_self);

    self->right = static_cast <CppCond_ShiftExpression*> (___el);
}

static ParserElement*
cpp_cond_RelationalExpression_Greater_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_RelationalExpression_Greater))) CppCond_RelationalExpression_Greater;
}

static Ref<Grammar>
create_cpp_cond_RelationalExpression_Greater ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_RelationalExpression_Greater_creation_func));
    grammar->name = String::forData ("RelationalExpression_Greater");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_Greater_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (">"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_Greater_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_RelationalExpression_Greater (CppCond_RelationalExpression_Greater const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) RelationalExpression_Greater\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("RelationalExpression_Greater\n");

    dump_cpp_cond_RelationalExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: >\n");
    dump_cpp_cond_ShiftExpression (el->right, nest_level + 1);

}

static void
cpp_cond_RelationalExpression_LessOrEqual_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_RelationalExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_LessOrEqual);

    CppCond_RelationalExpression_LessOrEqual * const &self = static_cast <CppCond_RelationalExpression_LessOrEqual*> (_self);

    self->left = static_cast <CppCond_RelationalExpression*> (___el);
}

static void
cpp_cond_RelationalExpression_LessOrEqual_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ShiftExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_LessOrEqual);

    CppCond_RelationalExpression_LessOrEqual * const &self = static_cast <CppCond_RelationalExpression_LessOrEqual*> (_self);

    self->right = static_cast <CppCond_ShiftExpression*> (___el);
}

static ParserElement*
cpp_cond_RelationalExpression_LessOrEqual_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_RelationalExpression_LessOrEqual))) CppCond_RelationalExpression_LessOrEqual;
}

static Ref<Grammar>
create_cpp_cond_RelationalExpression_LessOrEqual ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_RelationalExpression_LessOrEqual_creation_func));
    grammar->name = String::forData ("RelationalExpression_LessOrEqual");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_LessOrEqual_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("<="));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_LessOrEqual_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_RelationalExpression_LessOrEqual (CppCond_RelationalExpression_LessOrEqual const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) RelationalExpression_LessOrEqual\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("RelationalExpression_LessOrEqual\n");

    dump_cpp_cond_RelationalExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: <=\n");
    dump_cpp_cond_ShiftExpression (el->right, nest_level + 1);

}

static void
cpp_cond_RelationalExpression_GreaterOrEqual_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_RelationalExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_GreaterOrEqual);

    CppCond_RelationalExpression_GreaterOrEqual * const &self = static_cast <CppCond_RelationalExpression_GreaterOrEqual*> (_self);

    self->left = static_cast <CppCond_RelationalExpression*> (___el);
}

static void
cpp_cond_RelationalExpression_GreaterOrEqual_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_RelationalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ShiftExpression);

    CppCond_RelationalExpression * const &_self = static_cast <CppCond_RelationalExpression*> (__self);

    abortIf (_self->relational_expression_type != CppCond_RelationalExpression::_GreaterOrEqual);

    CppCond_RelationalExpression_GreaterOrEqual * const &self = static_cast <CppCond_RelationalExpression_GreaterOrEqual*> (_self);

    self->right = static_cast <CppCond_ShiftExpression*> (___el);
}

static ParserElement*
cpp_cond_RelationalExpression_GreaterOrEqual_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_RelationalExpression_GreaterOrEqual))) CppCond_RelationalExpression_GreaterOrEqual;
}

static Ref<Grammar>
create_cpp_cond_RelationalExpression_GreaterOrEqual ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_RelationalExpression_GreaterOrEqual_creation_func));
    grammar->name = String::forData ("RelationalExpression_GreaterOrEqual");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_GreaterOrEqual_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (">="));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ShiftExpression ();
        entry->assignment_func = cpp_cond_RelationalExpression_GreaterOrEqual_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_RelationalExpression_GreaterOrEqual (CppCond_RelationalExpression_GreaterOrEqual const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) RelationalExpression_GreaterOrEqual\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("RelationalExpression_GreaterOrEqual\n");

    dump_cpp_cond_RelationalExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: >=\n");
    dump_cpp_cond_ShiftExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_RelationalExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("RelationalExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression_Less ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression_Greater ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression_LessOrEqual ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression_GreaterOrEqual ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_RelationalExpression (CppCond_RelationalExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) RelationalExpression\n");
        return;
    }

    switch (el->relational_expression_type) {
        case CppCond_RelationalExpression::_Expression:
            dump_cpp_cond_RelationalExpression_Expression (static_cast <CppCond_RelationalExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_RelationalExpression::_Less:
            dump_cpp_cond_RelationalExpression_Less (static_cast <CppCond_RelationalExpression_Less const *> (el), nest_level + 0);
            break;
        case CppCond_RelationalExpression::_Greater:
            dump_cpp_cond_RelationalExpression_Greater (static_cast <CppCond_RelationalExpression_Greater const *> (el), nest_level + 0);
            break;
        case CppCond_RelationalExpression::_LessOrEqual:
            dump_cpp_cond_RelationalExpression_LessOrEqual (static_cast <CppCond_RelationalExpression_LessOrEqual const *> (el), nest_level + 0);
            break;
        case CppCond_RelationalExpression::_GreaterOrEqual:
            dump_cpp_cond_RelationalExpression_GreaterOrEqual (static_cast <CppCond_RelationalExpression_GreaterOrEqual const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_EqualityExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_EqualityExpression ||
             __el->cpp_cond_element_type != CppCondElement::_RelationalExpression);

    CppCond_EqualityExpression * const &_self = static_cast <CppCond_EqualityExpression*> (__self);

    abortIf (_self->equality_expression_type != CppCond_EqualityExpression::_Expression);

    CppCond_EqualityExpression_Expression * const &self = static_cast <CppCond_EqualityExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_RelationalExpression*> (___el);
}

static ParserElement*
cpp_cond_EqualityExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_EqualityExpression_Expression))) CppCond_EqualityExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_EqualityExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_EqualityExpression_Expression_creation_func));
    grammar->name = String::forData ("EqualityExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression ();
        entry->assignment_func = cpp_cond_EqualityExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_EqualityExpression_Expression (CppCond_EqualityExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) EqualityExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("EqualityExpression_Expression\n");

    dump_cpp_cond_RelationalExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_EqualityExpression_Equal_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_EqualityExpression ||
             __el->cpp_cond_element_type != CppCondElement::_EqualityExpression);

    CppCond_EqualityExpression * const &_self = static_cast <CppCond_EqualityExpression*> (__self);

    abortIf (_self->equality_expression_type != CppCond_EqualityExpression::_Equal);

    CppCond_EqualityExpression_Equal * const &self = static_cast <CppCond_EqualityExpression_Equal*> (_self);

    self->left = static_cast <CppCond_EqualityExpression*> (___el);
}

static void
cpp_cond_EqualityExpression_Equal_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_EqualityExpression ||
             __el->cpp_cond_element_type != CppCondElement::_RelationalExpression);

    CppCond_EqualityExpression * const &_self = static_cast <CppCond_EqualityExpression*> (__self);

    abortIf (_self->equality_expression_type != CppCond_EqualityExpression::_Equal);

    CppCond_EqualityExpression_Equal * const &self = static_cast <CppCond_EqualityExpression_Equal*> (_self);

    self->right = static_cast <CppCond_RelationalExpression*> (___el);
}

static ParserElement*
cpp_cond_EqualityExpression_Equal_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_EqualityExpression_Equal))) CppCond_EqualityExpression_Equal;
}

static Ref<Grammar>
create_cpp_cond_EqualityExpression_Equal ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_EqualityExpression_Equal_creation_func));
    grammar->name = String::forData ("EqualityExpression_Equal");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_EqualityExpression ();
        entry->assignment_func = cpp_cond_EqualityExpression_Equal_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("=="));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression ();
        entry->assignment_func = cpp_cond_EqualityExpression_Equal_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_EqualityExpression_Equal (CppCond_EqualityExpression_Equal const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) EqualityExpression_Equal\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("EqualityExpression_Equal\n");

    dump_cpp_cond_EqualityExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: ==\n");
    dump_cpp_cond_RelationalExpression (el->right, nest_level + 1);

}

static void
cpp_cond_EqualityExpression_NotEqual_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_EqualityExpression ||
             __el->cpp_cond_element_type != CppCondElement::_EqualityExpression);

    CppCond_EqualityExpression * const &_self = static_cast <CppCond_EqualityExpression*> (__self);

    abortIf (_self->equality_expression_type != CppCond_EqualityExpression::_NotEqual);

    CppCond_EqualityExpression_NotEqual * const &self = static_cast <CppCond_EqualityExpression_NotEqual*> (_self);

    self->left = static_cast <CppCond_EqualityExpression*> (___el);
}

static void
cpp_cond_EqualityExpression_NotEqual_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_EqualityExpression ||
             __el->cpp_cond_element_type != CppCondElement::_RelationalExpression);

    CppCond_EqualityExpression * const &_self = static_cast <CppCond_EqualityExpression*> (__self);

    abortIf (_self->equality_expression_type != CppCond_EqualityExpression::_NotEqual);

    CppCond_EqualityExpression_NotEqual * const &self = static_cast <CppCond_EqualityExpression_NotEqual*> (_self);

    self->right = static_cast <CppCond_RelationalExpression*> (___el);
}

static ParserElement*
cpp_cond_EqualityExpression_NotEqual_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_EqualityExpression_NotEqual))) CppCond_EqualityExpression_NotEqual;
}

static Ref<Grammar>
create_cpp_cond_EqualityExpression_NotEqual ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_EqualityExpression_NotEqual_creation_func));
    grammar->name = String::forData ("EqualityExpression_NotEqual");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_EqualityExpression ();
        entry->assignment_func = cpp_cond_EqualityExpression_NotEqual_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("!="));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_RelationalExpression ();
        entry->assignment_func = cpp_cond_EqualityExpression_NotEqual_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_EqualityExpression_NotEqual (CppCond_EqualityExpression_NotEqual const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) EqualityExpression_NotEqual\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("EqualityExpression_NotEqual\n");

    dump_cpp_cond_EqualityExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: !=\n");
    dump_cpp_cond_RelationalExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_EqualityExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("EqualityExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_EqualityExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_EqualityExpression_Equal ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_EqualityExpression_NotEqual ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_EqualityExpression (CppCond_EqualityExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) EqualityExpression\n");
        return;
    }

    switch (el->equality_expression_type) {
        case CppCond_EqualityExpression::_Expression:
            dump_cpp_cond_EqualityExpression_Expression (static_cast <CppCond_EqualityExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_EqualityExpression::_Equal:
            dump_cpp_cond_EqualityExpression_Equal (static_cast <CppCond_EqualityExpression_Equal const *> (el), nest_level + 0);
            break;
        case CppCond_EqualityExpression::_NotEqual:
            dump_cpp_cond_EqualityExpression_NotEqual (static_cast <CppCond_EqualityExpression_NotEqual const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_AndExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AndExpression ||
             __el->cpp_cond_element_type != CppCondElement::_EqualityExpression);

    CppCond_AndExpression * const &_self = static_cast <CppCond_AndExpression*> (__self);

    abortIf (_self->and_expression_type != CppCond_AndExpression::_Expression);

    CppCond_AndExpression_Expression * const &self = static_cast <CppCond_AndExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_EqualityExpression*> (___el);
}

static ParserElement*
cpp_cond_AndExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_AndExpression_Expression))) CppCond_AndExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_AndExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_AndExpression_Expression_creation_func));
    grammar->name = String::forData ("AndExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_EqualityExpression ();
        entry->assignment_func = cpp_cond_AndExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_AndExpression_Expression (CppCond_AndExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) AndExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("AndExpression_Expression\n");

    dump_cpp_cond_EqualityExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_AndExpression_And_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AndExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AndExpression);

    CppCond_AndExpression * const &_self = static_cast <CppCond_AndExpression*> (__self);

    abortIf (_self->and_expression_type != CppCond_AndExpression::_And);

    CppCond_AndExpression_And * const &self = static_cast <CppCond_AndExpression_And*> (_self);

    self->left = static_cast <CppCond_AndExpression*> (___el);
}

static void
cpp_cond_AndExpression_And_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_AndExpression ||
             __el->cpp_cond_element_type != CppCondElement::_EqualityExpression);

    CppCond_AndExpression * const &_self = static_cast <CppCond_AndExpression*> (__self);

    abortIf (_self->and_expression_type != CppCond_AndExpression::_And);

    CppCond_AndExpression_And * const &self = static_cast <CppCond_AndExpression_And*> (_self);

    self->right = static_cast <CppCond_EqualityExpression*> (___el);
}

static ParserElement*
cpp_cond_AndExpression_And_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_AndExpression_And))) CppCond_AndExpression_And;
}

static Ref<Grammar>
create_cpp_cond_AndExpression_And ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_AndExpression_And_creation_func));
    grammar->name = String::forData ("AndExpression_And");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AndExpression ();
        entry->assignment_func = cpp_cond_AndExpression_And_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("&"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_EqualityExpression ();
        entry->assignment_func = cpp_cond_AndExpression_And_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_AndExpression_And (CppCond_AndExpression_And const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) AndExpression_And\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("AndExpression_And\n");

    dump_cpp_cond_AndExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: &\n");
    dump_cpp_cond_EqualityExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_AndExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("AndExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_AndExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_AndExpression_And ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_AndExpression (CppCond_AndExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) AndExpression\n");
        return;
    }

    switch (el->and_expression_type) {
        case CppCond_AndExpression::_Expression:
            dump_cpp_cond_AndExpression_Expression (static_cast <CppCond_AndExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_AndExpression::_And:
            dump_cpp_cond_AndExpression_And (static_cast <CppCond_AndExpression_And const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_ExclusiveOrExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ExclusiveOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AndExpression);

    CppCond_ExclusiveOrExpression * const &_self = static_cast <CppCond_ExclusiveOrExpression*> (__self);

    abortIf (_self->exclusive_or_expression_type != CppCond_ExclusiveOrExpression::_Expression);

    CppCond_ExclusiveOrExpression_Expression * const &self = static_cast <CppCond_ExclusiveOrExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_AndExpression*> (___el);
}

static ParserElement*
cpp_cond_ExclusiveOrExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_ExclusiveOrExpression_Expression))) CppCond_ExclusiveOrExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_ExclusiveOrExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_ExclusiveOrExpression_Expression_creation_func));
    grammar->name = String::forData ("ExclusiveOrExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AndExpression ();
        entry->assignment_func = cpp_cond_ExclusiveOrExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ExclusiveOrExpression_Expression (CppCond_ExclusiveOrExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ExclusiveOrExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("ExclusiveOrExpression_Expression\n");

    dump_cpp_cond_AndExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_ExclusiveOrExpression_ExclusiveOr_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ExclusiveOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ExclusiveOrExpression);

    CppCond_ExclusiveOrExpression * const &_self = static_cast <CppCond_ExclusiveOrExpression*> (__self);

    abortIf (_self->exclusive_or_expression_type != CppCond_ExclusiveOrExpression::_ExclusiveOr);

    CppCond_ExclusiveOrExpression_ExclusiveOr * const &self = static_cast <CppCond_ExclusiveOrExpression_ExclusiveOr*> (_self);

    self->left = static_cast <CppCond_ExclusiveOrExpression*> (___el);
}

static void
cpp_cond_ExclusiveOrExpression_ExclusiveOr_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ExclusiveOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_AndExpression);

    CppCond_ExclusiveOrExpression * const &_self = static_cast <CppCond_ExclusiveOrExpression*> (__self);

    abortIf (_self->exclusive_or_expression_type != CppCond_ExclusiveOrExpression::_ExclusiveOr);

    CppCond_ExclusiveOrExpression_ExclusiveOr * const &self = static_cast <CppCond_ExclusiveOrExpression_ExclusiveOr*> (_self);

    self->right = static_cast <CppCond_AndExpression*> (___el);
}

static ParserElement*
cpp_cond_ExclusiveOrExpression_ExclusiveOr_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_ExclusiveOrExpression_ExclusiveOr))) CppCond_ExclusiveOrExpression_ExclusiveOr;
}

static Ref<Grammar>
create_cpp_cond_ExclusiveOrExpression_ExclusiveOr ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_ExclusiveOrExpression_ExclusiveOr_creation_func));
    grammar->name = String::forData ("ExclusiveOrExpression_ExclusiveOr");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ExclusiveOrExpression ();
        entry->assignment_func = cpp_cond_ExclusiveOrExpression_ExclusiveOr_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("^"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_AndExpression ();
        entry->assignment_func = cpp_cond_ExclusiveOrExpression_ExclusiveOr_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ExclusiveOrExpression_ExclusiveOr (CppCond_ExclusiveOrExpression_ExclusiveOr const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ExclusiveOrExpression_ExclusiveOr\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("ExclusiveOrExpression_ExclusiveOr\n");

    dump_cpp_cond_ExclusiveOrExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: ^\n");
    dump_cpp_cond_AndExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_ExclusiveOrExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("ExclusiveOrExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_ExclusiveOrExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_ExclusiveOrExpression_ExclusiveOr ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ExclusiveOrExpression (CppCond_ExclusiveOrExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ExclusiveOrExpression\n");
        return;
    }

    switch (el->exclusive_or_expression_type) {
        case CppCond_ExclusiveOrExpression::_Expression:
            dump_cpp_cond_ExclusiveOrExpression_Expression (static_cast <CppCond_ExclusiveOrExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_ExclusiveOrExpression::_ExclusiveOr:
            dump_cpp_cond_ExclusiveOrExpression_ExclusiveOr (static_cast <CppCond_ExclusiveOrExpression_ExclusiveOr const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_InclusiveOrExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_InclusiveOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ExclusiveOrExpression);

    CppCond_InclusiveOrExpression * const &_self = static_cast <CppCond_InclusiveOrExpression*> (__self);

    abortIf (_self->inclusive_or_expression_type != CppCond_InclusiveOrExpression::_Expression);

    CppCond_InclusiveOrExpression_Expression * const &self = static_cast <CppCond_InclusiveOrExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_ExclusiveOrExpression*> (___el);
}

static ParserElement*
cpp_cond_InclusiveOrExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_InclusiveOrExpression_Expression))) CppCond_InclusiveOrExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_InclusiveOrExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_InclusiveOrExpression_Expression_creation_func));
    grammar->name = String::forData ("InclusiveOrExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ExclusiveOrExpression ();
        entry->assignment_func = cpp_cond_InclusiveOrExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_InclusiveOrExpression_Expression (CppCond_InclusiveOrExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) InclusiveOrExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("InclusiveOrExpression_Expression\n");

    dump_cpp_cond_ExclusiveOrExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_InclusiveOrExpression_InclusiveOr_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_InclusiveOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_InclusiveOrExpression);

    CppCond_InclusiveOrExpression * const &_self = static_cast <CppCond_InclusiveOrExpression*> (__self);

    abortIf (_self->inclusive_or_expression_type != CppCond_InclusiveOrExpression::_InclusiveOr);

    CppCond_InclusiveOrExpression_InclusiveOr * const &self = static_cast <CppCond_InclusiveOrExpression_InclusiveOr*> (_self);

    self->left = static_cast <CppCond_InclusiveOrExpression*> (___el);
}

static void
cpp_cond_InclusiveOrExpression_InclusiveOr_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_InclusiveOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ExclusiveOrExpression);

    CppCond_InclusiveOrExpression * const &_self = static_cast <CppCond_InclusiveOrExpression*> (__self);

    abortIf (_self->inclusive_or_expression_type != CppCond_InclusiveOrExpression::_InclusiveOr);

    CppCond_InclusiveOrExpression_InclusiveOr * const &self = static_cast <CppCond_InclusiveOrExpression_InclusiveOr*> (_self);

    self->right = static_cast <CppCond_ExclusiveOrExpression*> (___el);
}

static ParserElement*
cpp_cond_InclusiveOrExpression_InclusiveOr_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_InclusiveOrExpression_InclusiveOr))) CppCond_InclusiveOrExpression_InclusiveOr;
}

static Ref<Grammar>
create_cpp_cond_InclusiveOrExpression_InclusiveOr ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_InclusiveOrExpression_InclusiveOr_creation_func));
    grammar->name = String::forData ("InclusiveOrExpression_InclusiveOr");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_InclusiveOrExpression ();
        entry->assignment_func = cpp_cond_InclusiveOrExpression_InclusiveOr_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("|"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ExclusiveOrExpression ();
        entry->assignment_func = cpp_cond_InclusiveOrExpression_InclusiveOr_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_InclusiveOrExpression_InclusiveOr (CppCond_InclusiveOrExpression_InclusiveOr const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) InclusiveOrExpression_InclusiveOr\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("InclusiveOrExpression_InclusiveOr\n");

    dump_cpp_cond_InclusiveOrExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: |\n");
    dump_cpp_cond_ExclusiveOrExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_InclusiveOrExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("InclusiveOrExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_InclusiveOrExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_InclusiveOrExpression_InclusiveOr ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_InclusiveOrExpression (CppCond_InclusiveOrExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) InclusiveOrExpression\n");
        return;
    }

    switch (el->inclusive_or_expression_type) {
        case CppCond_InclusiveOrExpression::_Expression:
            dump_cpp_cond_InclusiveOrExpression_Expression (static_cast <CppCond_InclusiveOrExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_InclusiveOrExpression::_InclusiveOr:
            dump_cpp_cond_InclusiveOrExpression_InclusiveOr (static_cast <CppCond_InclusiveOrExpression_InclusiveOr const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_LogicalAndExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_LogicalAndExpression ||
             __el->cpp_cond_element_type != CppCondElement::_InclusiveOrExpression);

    CppCond_LogicalAndExpression * const &_self = static_cast <CppCond_LogicalAndExpression*> (__self);

    abortIf (_self->logical_and_expression_type != CppCond_LogicalAndExpression::_Expression);

    CppCond_LogicalAndExpression_Expression * const &self = static_cast <CppCond_LogicalAndExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_InclusiveOrExpression*> (___el);
}

static ParserElement*
cpp_cond_LogicalAndExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_LogicalAndExpression_Expression))) CppCond_LogicalAndExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_LogicalAndExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_LogicalAndExpression_Expression_creation_func));
    grammar->name = String::forData ("LogicalAndExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_InclusiveOrExpression ();
        entry->assignment_func = cpp_cond_LogicalAndExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_LogicalAndExpression_Expression (CppCond_LogicalAndExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) LogicalAndExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("LogicalAndExpression_Expression\n");

    dump_cpp_cond_InclusiveOrExpression (el->expression, nest_level + 1);

}

static void
cpp_cond_LogicalAndExpression_LogicalAnd_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_LogicalAndExpression ||
             __el->cpp_cond_element_type != CppCondElement::_LogicalAndExpression);

    CppCond_LogicalAndExpression * const &_self = static_cast <CppCond_LogicalAndExpression*> (__self);

    abortIf (_self->logical_and_expression_type != CppCond_LogicalAndExpression::_LogicalAnd);

    CppCond_LogicalAndExpression_LogicalAnd * const &self = static_cast <CppCond_LogicalAndExpression_LogicalAnd*> (_self);

    self->left = static_cast <CppCond_LogicalAndExpression*> (___el);
}

static void
cpp_cond_LogicalAndExpression_LogicalAnd_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_LogicalAndExpression ||
             __el->cpp_cond_element_type != CppCondElement::_InclusiveOrExpression);

    CppCond_LogicalAndExpression * const &_self = static_cast <CppCond_LogicalAndExpression*> (__self);

    abortIf (_self->logical_and_expression_type != CppCond_LogicalAndExpression::_LogicalAnd);

    CppCond_LogicalAndExpression_LogicalAnd * const &self = static_cast <CppCond_LogicalAndExpression_LogicalAnd*> (_self);

    self->right = static_cast <CppCond_InclusiveOrExpression*> (___el);
}

static ParserElement*
cpp_cond_LogicalAndExpression_LogicalAnd_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_LogicalAndExpression_LogicalAnd))) CppCond_LogicalAndExpression_LogicalAnd;
}

static Ref<Grammar>
create_cpp_cond_LogicalAndExpression_LogicalAnd ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_LogicalAndExpression_LogicalAnd_creation_func));
    grammar->name = String::forData ("LogicalAndExpression_LogicalAnd");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalAndExpression ();
        entry->assignment_func = cpp_cond_LogicalAndExpression_LogicalAnd_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("&&"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_InclusiveOrExpression ();
        entry->assignment_func = cpp_cond_LogicalAndExpression_LogicalAnd_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_LogicalAndExpression_LogicalAnd (CppCond_LogicalAndExpression_LogicalAnd const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) LogicalAndExpression_LogicalAnd\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("LogicalAndExpression_LogicalAnd\n");

    dump_cpp_cond_LogicalAndExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: &&\n");
    dump_cpp_cond_InclusiveOrExpression (el->right, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_LogicalAndExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("LogicalAndExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalAndExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalAndExpression_LogicalAnd ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_LogicalAndExpression (CppCond_LogicalAndExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) LogicalAndExpression\n");
        return;
    }

    switch (el->logical_and_expression_type) {
        case CppCond_LogicalAndExpression::_Expression:
            dump_cpp_cond_LogicalAndExpression_Expression (static_cast <CppCond_LogicalAndExpression_Expression const *> (el), nest_level + 0);
            break;
        case CppCond_LogicalAndExpression::_LogicalAnd:
            dump_cpp_cond_LogicalAndExpression_LogicalAnd (static_cast <CppCond_LogicalAndExpression_LogicalAnd const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_LogicalOrExpression_LogicalOr_set_left (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_LogicalOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_LogicalOrExpression);

    CppCond_LogicalOrExpression * const &_self = static_cast <CppCond_LogicalOrExpression*> (__self);

    abortIf (_self->logical_or_expression_type != CppCond_LogicalOrExpression::_LogicalOr);

    CppCond_LogicalOrExpression_LogicalOr * const &self = static_cast <CppCond_LogicalOrExpression_LogicalOr*> (_self);

    self->left = static_cast <CppCond_LogicalOrExpression*> (___el);
}

static void
cpp_cond_LogicalOrExpression_LogicalOr_set_right (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_LogicalOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_LogicalAndExpression);

    CppCond_LogicalOrExpression * const &_self = static_cast <CppCond_LogicalOrExpression*> (__self);

    abortIf (_self->logical_or_expression_type != CppCond_LogicalOrExpression::_LogicalOr);

    CppCond_LogicalOrExpression_LogicalOr * const &self = static_cast <CppCond_LogicalOrExpression_LogicalOr*> (_self);

    self->right = static_cast <CppCond_LogicalAndExpression*> (___el);
}

static ParserElement*
cpp_cond_LogicalOrExpression_LogicalOr_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_LogicalOrExpression_LogicalOr))) CppCond_LogicalOrExpression_LogicalOr;
}

static Ref<Grammar>
create_cpp_cond_LogicalOrExpression_LogicalOr ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_LogicalOrExpression_LogicalOr_creation_func));
    grammar->name = String::forData ("LogicalOrExpression_LogicalOr");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalOrExpression ();
        entry->assignment_func = cpp_cond_LogicalOrExpression_LogicalOr_set_left;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("||"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalAndExpression ();
        entry->assignment_func = cpp_cond_LogicalOrExpression_LogicalOr_set_right;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_LogicalOrExpression_LogicalOr (CppCond_LogicalOrExpression_LogicalOr const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) LogicalOrExpression_LogicalOr\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("LogicalOrExpression_LogicalOr\n");

    dump_cpp_cond_LogicalOrExpression (el->left, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: ||\n");
    dump_cpp_cond_LogicalAndExpression (el->right, nest_level + 1);

}

static void
cpp_cond_LogicalOrExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_LogicalOrExpression ||
             __el->cpp_cond_element_type != CppCondElement::_LogicalAndExpression);

    CppCond_LogicalOrExpression * const &_self = static_cast <CppCond_LogicalOrExpression*> (__self);

    abortIf (_self->logical_or_expression_type != CppCond_LogicalOrExpression::_Expression);

    CppCond_LogicalOrExpression_Expression * const &self = static_cast <CppCond_LogicalOrExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_LogicalAndExpression*> (___el);
}

static ParserElement*
cpp_cond_LogicalOrExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_LogicalOrExpression_Expression))) CppCond_LogicalOrExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_LogicalOrExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_LogicalOrExpression_Expression_creation_func));
    grammar->name = String::forData ("LogicalOrExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalAndExpression ();
        entry->assignment_func = cpp_cond_LogicalOrExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_LogicalOrExpression_Expression (CppCond_LogicalOrExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) LogicalOrExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("LogicalOrExpression_Expression\n");

    dump_cpp_cond_LogicalAndExpression (el->expression, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_LogicalOrExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("LogicalOrExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalOrExpression_LogicalOr ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalOrExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_LogicalOrExpression (CppCond_LogicalOrExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) LogicalOrExpression\n");
        return;
    }

    switch (el->logical_or_expression_type) {
        case CppCond_LogicalOrExpression::_LogicalOr:
            dump_cpp_cond_LogicalOrExpression_LogicalOr (static_cast <CppCond_LogicalOrExpression_LogicalOr const *> (el), nest_level + 0);
            break;
        case CppCond_LogicalOrExpression::_Expression:
            dump_cpp_cond_LogicalOrExpression_Expression (static_cast <CppCond_LogicalOrExpression_Expression const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_ConditionalExpression_Conditional_set_conditionExpression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ConditionalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_LogicalOrExpression);

    CppCond_ConditionalExpression * const &_self = static_cast <CppCond_ConditionalExpression*> (__self);

    abortIf (_self->conditional_expression_type != CppCond_ConditionalExpression::_Conditional);

    CppCond_ConditionalExpression_Conditional * const &self = static_cast <CppCond_ConditionalExpression_Conditional*> (_self);

    self->conditionExpression = static_cast <CppCond_LogicalOrExpression*> (___el);
}

static void
cpp_cond_ConditionalExpression_Conditional_set_ifExpression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ConditionalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ConditionalExpression);

    CppCond_ConditionalExpression * const &_self = static_cast <CppCond_ConditionalExpression*> (__self);

    abortIf (_self->conditional_expression_type != CppCond_ConditionalExpression::_Conditional);

    CppCond_ConditionalExpression_Conditional * const &self = static_cast <CppCond_ConditionalExpression_Conditional*> (_self);

    self->ifExpression = static_cast <CppCond_ConditionalExpression*> (___el);
}

static void
cpp_cond_ConditionalExpression_Conditional_set_elseExpression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ConditionalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_ConditionalExpression);

    CppCond_ConditionalExpression * const &_self = static_cast <CppCond_ConditionalExpression*> (__self);

    abortIf (_self->conditional_expression_type != CppCond_ConditionalExpression::_Conditional);

    CppCond_ConditionalExpression_Conditional * const &self = static_cast <CppCond_ConditionalExpression_Conditional*> (_self);

    self->elseExpression = static_cast <CppCond_ConditionalExpression*> (___el);
}

static ParserElement*
cpp_cond_ConditionalExpression_Conditional_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_ConditionalExpression_Conditional))) CppCond_ConditionalExpression_Conditional;
}

static Ref<Grammar>
create_cpp_cond_ConditionalExpression_Conditional ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_ConditionalExpression_Conditional_creation_func));
    grammar->name = String::forData ("ConditionalExpression_Conditional");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalOrExpression ();
        entry->assignment_func = cpp_cond_ConditionalExpression_Conditional_set_conditionExpression;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken ("?"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ConditionalExpression ();
        entry->assignment_func = cpp_cond_ConditionalExpression_Conditional_set_ifExpression;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());

        Ref<Grammar_Immediate_SingleToken> grammar__immediate = grab (new Grammar_Immediate_SingleToken (":"));
        entry->grammar = grammar__immediate;
        grammar->grammar_entries.append (entry);
    }

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ConditionalExpression ();
        entry->assignment_func = cpp_cond_ConditionalExpression_Conditional_set_elseExpression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ConditionalExpression_Conditional (CppCond_ConditionalExpression_Conditional const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ConditionalExpression_Conditional\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("ConditionalExpression_Conditional\n");

    dump_cpp_cond_LogicalOrExpression (el->conditionExpression, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: ?\n");
    dump_cpp_cond_ConditionalExpression (el->ifExpression, nest_level + 1);

    print_tab (errf, nest_level + 1);
    errf->print ("token: :\n");
    dump_cpp_cond_ConditionalExpression (el->elseExpression, nest_level + 1);

}

static void
cpp_cond_ConditionalExpression_Expression_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_ConditionalExpression ||
             __el->cpp_cond_element_type != CppCondElement::_LogicalOrExpression);

    CppCond_ConditionalExpression * const &_self = static_cast <CppCond_ConditionalExpression*> (__self);

    abortIf (_self->conditional_expression_type != CppCond_ConditionalExpression::_Expression);

    CppCond_ConditionalExpression_Expression * const &self = static_cast <CppCond_ConditionalExpression_Expression*> (_self);

    self->expression = static_cast <CppCond_LogicalOrExpression*> (___el);
}

static ParserElement*
cpp_cond_ConditionalExpression_Expression_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_ConditionalExpression_Expression))) CppCond_ConditionalExpression_Expression;
}

static Ref<Grammar>
create_cpp_cond_ConditionalExpression_Expression ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_ConditionalExpression_Expression_creation_func));
    grammar->name = String::forData ("ConditionalExpression_Expression");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_LogicalOrExpression ();
        entry->assignment_func = cpp_cond_ConditionalExpression_Expression_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ConditionalExpression_Expression (CppCond_ConditionalExpression_Expression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ConditionalExpression_Expression\n");
        return;
    }

    print_tab (errf, nest_level);
    errf->print ("ConditionalExpression_Expression\n");

    dump_cpp_cond_LogicalOrExpression (el->expression, nest_level + 1);

}

static Ref<Grammar>
create_cpp_cond_ConditionalExpression ()
{
    static Ref<Grammar_Switch> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Switch ());
    grammar->name = String::forData ("ConditionalExpression");

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_ConditionalExpression_Conditional ();

        grammar->grammar_entries.append (entry);
    }

    {
        Ref<SwitchGrammarEntry> entry = grab (new SwitchGrammarEntry ());
        entry->grammar = create_cpp_cond_ConditionalExpression_Expression ();

        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_ConditionalExpression (CppCond_ConditionalExpression const *el, Size nest_level)
{
    if (el == NULL) {
        print_tab (errf, nest_level);
        errf->print ("(null) ConditionalExpression\n");
        return;
    }

    switch (el->conditional_expression_type) {
        case CppCond_ConditionalExpression::_Conditional:
            dump_cpp_cond_ConditionalExpression_Conditional (static_cast <CppCond_ConditionalExpression_Conditional const *> (el), nest_level + 0);
            break;
        case CppCond_ConditionalExpression::_Expression:
            dump_cpp_cond_ConditionalExpression_Expression (static_cast <CppCond_ConditionalExpression_Expression const *> (el), nest_level + 0);
            break;
        default:
            abortIfReached ();
    }
}

static void
cpp_cond_Grammar_set_expression (
        ParserElement *___self,
        ParserElement *___el)
{
    if (___self == NULL ||
        ___el == NULL)
    {
        return;
    }

    CppCondElement * const &__self = static_cast <CppCondElement*> (___self);
    CppCondElement * const &__el = static_cast <CppCondElement*> (___el);

    abortIf (__self->cpp_cond_element_type != CppCondElement::_Grammar ||
             __el->cpp_cond_element_type != CppCondElement::_ConditionalExpression);

    CppCond_Grammar * const &self = static_cast <CppCond_Grammar*> (__self);

    self->expression = static_cast <CppCond_ConditionalExpression*> (___el);
}

static ParserElement*
cpp_cond_Grammar_creation_func (VStack * const vstack /* non-null */)
{
    return new (vstack->push_malign (sizeof (CppCond_Grammar))) CppCond_Grammar;
}

Ref<Grammar>
create_cpp_cond_grammar ()
{
    static Ref<Grammar_Compound> grammar;
    if (!grammar.isNull ())
        return grammar.ptr ();

    grammar = grab (new Grammar_Compound (cpp_cond_Grammar_creation_func));
    grammar->name = String::forData ("Grammar");

    {
        Ref<CompoundGrammarEntry> entry = grab (new CompoundGrammarEntry ());
        entry->grammar = create_cpp_cond_ConditionalExpression ();
        entry->assignment_func = cpp_cond_Grammar_set_expression;
        grammar->grammar_entries.append (entry);
    }

    return grammar.ptr ();
}

void
dump_cpp_cond_grammar (CppCond_Grammar const *el)
{
    if (el == NULL) {
        print_tab (errf, 0);
        errf->print ("(null) Grammar\n");
        return;
    }

    errf->print ("Grammar\n");

    dump_cpp_cond_ConditionalExpression (el->expression, 1);

}

}

